'______________________________________________
'                          Validating Data With Class
'                                Created 3/26/08
'______________________________________________

'This form represents data entry for an ATM or similar process.
'The data is validated using my DataValidation Class.

'The purpose of this demo is to show you how to use pass the name of the
'control you want to validate to a class method instead of doing it every time
'in your form.

'You pass the name of the control and a description to the DataValidation Class. It checks
'your data and returns True or false. It also displays a message box with a description of the 
'problem control and sets the focus to that control.

'When all the data is validated, the btnOK_Click event adds the new deposit to the beginning balance.

Public Class frmMain

    Dim myValidator As New DataValidation

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        '---add the new deposit only if the data in the form is correct!

        Try


            '---test all fields
            If myValidator.IsPresent(txtFirst, "First Name") = True AndAlso _
                myValidator.IsString(txtFirst, "First Name") = True AndAlso _
                myValidator.IsPresent(txtLast, "Last Name") = True AndAlso _
                myValidator.IsString(txtLast, "Last Name") = True AndAlso _
                myValidator.IsInteger(txtAge, "Your age") = True AndAlso _
                myValidator.IsDate(mskDOB, "Birthdate") = True AndAlso _
                myValidator.IsDecimal(txtDeposit, "Deposit Amount") = True AndAlso _
                myValidator.IsWithinRange(txtDeposit, "Deposit Amount", 1, 1000) = True Then

                '---finally, make it so!
                txtNewBalance.Text = FormatNumber(CDec(txtStartingBalance.Text) + CDec(txtDeposit.Text))
                MessageBox.Show("Your deposit has been accepted!", "Deposit confirmation", _
                    MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If

        Catch ex As Exception

            MessageBox.Show("Please contact customer support. Your data cannot be confirmed." & ex.Message, "System Message", _
                MessageBoxButtons.OK, MessageBoxIcon.Error)

        End Try

    End Sub
End Class
